/**
 * Present.java
 *
 * File generated from the XValidator4::Present uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import java.util.ArrayList;
import java.util.Map;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.exception.NoNodeSelectedException;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import net.ihe.gazelle.xvalidation.core.xpath.XpathUtils;

import net.sf.saxon.dom.DOMNodeList;
import org.w3c.dom.Node;

/**
 * Description of the class Present.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Present", propOrder = { "locator" })
@XmlRootElement(name = "Present")
@Entity
@DiscriminatorValue("present")
public class Present extends AbstractExpression implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@XmlElement(name = "Locator", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "locator_id")
	private Locator locator;

	public Present() {
		super();
		this.locator = new Locator();
	}

	public Present(Present exp) {
		super();
		this.locator = new Locator(exp.getLocator());
	}

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return locator.
	 * 
	 * @return locator
	 */
	public Locator getLocator() {
		return locator;
	}

	/**
	 * Set a value to attribute locator.
	 * 
	 * @param locator
	 *            .
	 */
	public void setLocator(Locator locator) {
		this.locator = locator;
	}

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Present", this);
		}
		return xmlNodePresentation;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public Notification evaluate(Map<String, Node> files, ValidatorConfiguration configuration, Level level) {

		boolean result = true;
		DOMNodeList xpathResult = null;

		try {
			xpathResult = XpathUtils.getNodesFromDOM(files.get(locator.getAppliesOn()), locator, configuration.getNamespaceContext());
		} catch (NoNodeSelectedException e) {
			result = false;
		} catch (GazelleXValidationException e){
			return abort("Error evaluating XPath : " + e.getMessage(), locator, "Error evaluating XPath " + locator.toString() + " : " + e.getMessage());
		}

		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport("PRESENT " + XpathUtils.getXPathReport(locator, xpathResult));
		return resultNotification;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append(' ');
		builder.append(this.locator.toString());
		builder.append(" is present");
		return builder.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((locator == null) ? 0 : locator.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Present other = (Present) obj;
		if (locator == null) {
			if (other.locator != null) {
				return false;
			}
		} else if (!locator.equals(other.locator)) {
			return false;
		}
		return true;
	}

	@Override
	public String getEditLink() {
		return "/xvalidation/expressions/present.xhtml";
	}

	@Override
	public void testCorrectness() throws AssertionFailedError {
		Assert.assertNotNull("[Expression #" + getFakeId() + "] Locator is missing", locator);
		Assert.assertTrue("[Expression #" + getFakeId() + "] Locator is not correctly filled", locator.isValued());
	}

	@Override
	public ArrayList<String> appliesTo() throws AssertionFailedError {
		ArrayList<String> keywords = new ArrayList<String>();
		testCorrectness();
		keywords.add(locator.getAppliesOn());
		return keywords;
	}

	@Override
	public AbstractExpression createCopy() {
		return new Present(this);
	}
}